Attribute VB_Name = "asmLong"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Declare Sub API_CopyByRef _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)

Private Declare Function ASM_cdRF3 _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Long, _
    ByRef PA1 As Long, _
    ByRef PA2 As Long, _
    ByVal PA3 As Long, _
    ByVal PA4 As Long) As Long

' LNG2CHR   Convert longs to string (*)
'
' CALL:     LNG2CHR(src, [bnd], [flg:Cnv2Unicode])
'
' IN:       ptr:src Long v longarray
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           bol:flg .T.: Convert to unicode (dflt)
'                   .F.: Do not convert to unicode
'
' OUT:      chr     chr converted array
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for src:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'
' Caution:  The unicode conversion does not only include a zero
'           after each character (i.E. &H91 becomes 12 20). This
'           may cause differences between the strings and the
'           longs. Hence, you must re-convert the string returned
'           to ansi before using it.
'
Function LNG2CHR( _
    src As Long, _
    Optional bnd As Long = 0, _
    Optional Cnv2Unicode As Boolean = True) As String
    
    Dim bar() As Byte
    
    ReDim bar(bnd * 4 + 3)
    API_CopyByRef ByVal VarPtr(bar(0)), src, UBound(bar) + 1
    
    If Cnv2Unicode Then
        LNG2CHR = StrConv(bar, vbUnicode)
    Else
        LNG2CHR = bar
    End If
End Function

' lngCMP    Compare longs
'
' CALL:     lngCMP(pa1, pa2, [bnd], [@pos])
'
' IN:       ptr:pa1 Long v longarray
'           ptr:pa2 Long v longarray
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           lng:pos Placeholder for position of first difference
'
' OUT:      bol     .T.: pa1=pa2  (pos = unchanged)
'                   .F.: pa1<>pa2 (pos = first difference)
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for pa1/pa2:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple compare command was lngCMP(V1, V2), but
'             this could be fullfilled much faster via If V1=V2, so
'             this function is really made for to compare arrays
'
Function lngCMP( _
    PA1 As Long, _
    PA2 As Long, _
    Optional bnd As Long = 0, _
    Optional pos As Long) As Boolean
    
    Static asm(10) As Long

    If asm(0) = 0 Then
        asm(0) = &H748B5756:  asm(1) = &H7C8B0C24:  asm(2) = &H4C8B1024
        asm(3) = &HF3411424:  asm(4) = &HFF418DA7:  asm(5) = &H442B0E74
        asm(6) = &HD0F71424:  asm(7) = &H18247C8B:  asm(8) = &HC0330789
        asm(9) = &H10C25E5F:  asm(10) = &H0
    End If
    
    ' *******************************************************************

    lngCMP = ASM_cdRF3(asm(0), PA1, PA2, bnd, VarPtr(pos))
End Function

' lngRND    Create random figure(s)
'           acc. to the formula of Park & Miller in:
'           actvieVB, "Advanced Vigenre"
'
' CALL:     lngRND(@sat, [bnd], [min], [max], [def])
'
' IN:       ptr:sat Long v longarray
'           lng:bnd Bound - zerobased loopcount     (dflt=0)
'           lng:min Minimum value [with bnd=0 only] (dflt=0)
'           lng:max Maximum value [with bnd=0 only] (dflt=&H7FFFFFFD)
'           lng:def Initialization value (in case of [sat]=zero)
'
' OUT:      lng     Last processed value -1
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for sat/pa2:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple random command is done via lngRND()
'             Initiating an array of values was:
'             Dim sat(10): lngRND sat(0), 10
'           - If using lngRND with arrays, all target values
'             are 1-based! (use: sat(x)-1 in calculations)
'
' Caution:  - If (sat[x] Or def) equals to zero the CPU-ticker
'             is taken for initialization. This command requires
'             a pentium processor!
'
Function lngRND( _
    Optional sat As Long, _
    Optional bnd As Long, _
    Optional min As Long, _
    Optional max As Long, _
    Optional def As Long) As Long
    
    Static asm(33) As Long

    If asm(0) = 0 Then
        asm(0) = &HC8685790:  asm(1) = &H680000AD:  asm(2) = &HD47
        asm(3) = &HBC8F68:    asm(4) = &H247C8B00:  asm(5) = &H244C8B14
        asm(6) = &H8F048B1C:  asm(7) = &H2A7FC00B:  asm(8) = &H474D8F7
        asm(9) = &HC0332479:  asm(10) = &H2024440B: asm(11) = &H1A790674
        asm(12) = &H16EBE8D1: asm(13) = &HB151310F: asm(14) = &HD3C82207
        asm(15) = &H33C533C0: asm(16) = &H3CAD3D7:  asm(17) = &HD87859C2
        asm(18) = &HF799EA74: asm(19) = &H52082474: asm(20) = &H543BE2D1
        asm(21) = &HA720C24:  asm(22) = &H1A90775:  asm(23) = &H74000000
        asm(24) = &H64F74001: asm(25) = &H4870824:  asm(26) = &H2464F724
        asm(27) = &HC22B5A04: asm(28) = &HFF050579: asm(29) = &H897FFFFF
        asm(30) = &H79498F04: asm(31) = &HC483489C: asm(32) = &H10C25F0C
        asm(33) = &H0
    End If
    
    ' *******************************************************************

    Dim ret As Long
    Dim tmp As Long
    
    ret = ASM_cdRF3(asm(0), sat, 0, bnd, def)
    
    If bnd = 0 And (min Or max) Then
        If min > max Then tmp = min: min = max: max = tmp
        If min >= 0 And max <= &H7FFFFFFD Then
            ret = min + (ret Mod (max - min + 1))
        Else
            ret = 0
        End If
    End If
    
    lngRND = ret
End Function

' lngROL    Left-rotate longs
'
' CALL:     lngROL(sat/@sat, [cnt], [bnd], [cmd])
'
' IN:       ptr:sat Long v longarray
'                   This value wont be changed, with
'                   cnt=0 and cmd=1
'           lng:cnt Number of bits to rotate (dflt=1)
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           lng:cmd 0: result = rol(sat) (dflt)
'                   1: sat[0] = rol(sat[0]) ... sat[bnd] = rol(sat[bnd])
'                   3: sat[0...bnd] = rol(sat[0...bnd])
'
' OUT:      cmd=0   sat Lrotate cnt
'           cmd=1/3 undefined
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for sat:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple rotate command was lngROL(V1, x)
'           - If using bnd>0, be aware that the most significant
'             dWord is expected at the array's highest position,
'             hence, the memory is physically rotated to the right!
'
Function lngROL( _
    sat As Long, _
    Optional cnt As Long = 1, _
    Optional bnd As Long = 0, _
    Optional cmd As Long = 0) As Long
    
    Static asm(35) As Long

    If asm(0) = 0 Then
        asm(0) = &H247C8B57:  asm(1) = &H244C8B08:  asm(2) = &H2464C010
        asm(3) = &H14740614:  asm(4) = &HC24548B:   asm(5) = &H107B0679
        asm(6) = &H1075D20B:  asm(7) = &H4A9704D3:  asm(8) = &H4EBFA79
        asm(9) = &HC0D3078B:  asm(10) = &H10C25F:   asm(11) = &H40C28B52
        asm(12) = &H5E8C191:  asm(13) = &HC1F1F799: asm(14) = &H2E7402E2
        asm(15) = &H8B535655: asm(16) = &H8D348DEF: asm(17) = &H0
        asm(18) = &H573E1C8D: asm(19) = &H78BFD8B:  asm(20) = &HFB3BFA03
        asm(21) = &HFE2B0272: asm(22) = &H74490787: asm(23) = &H75FD3B09
        asm(24) = &H4C583EF:  asm(25) = &H5B5FE6EB: asm(26) = &HB95A5D5E
        asm(27) = &H1F:       asm(28) = &H10244C23: asm(29) = &H3C8DB274
        asm(30) = &H8B37FF97: asm(31) = &HA50FFC47: asm(32) = &H4EF8307
        asm(33) = &H58F4754A: asm(34) = &HEB07A50F: asm(35) = &H9B
    End If

    ' *******************************************************************

    lngROL = ASM_cdRF3(asm(0), sat, ByVal bnd, cnt, cmd)
End Function

' lngROR    Right-rotate longs
'
' CALL:     lngROR(@sat, [cnt], [bnd], [cmd])
'
' IN:       ptr:sat Long v longarray
'                   This value wont be changed, with
'                   cnt=0 and cmd=1
'           lng:cnt Number of bits to rotate (dflt=1)
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           lng:cmd 0: result = ror(sat) (dflt)
'                   1: sat[0] = ror(sat[0]) ... sat[bnd = ror(sat[bnd])
'                   3: sat[0...bnd] = ror(sat[0...bnd])
'
' OUT:      cmd=0   sat Rrotate cnt
'           cmd=1/3 undefined
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for sat:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple rotate command was lngROR(V1, x)
'           - If using bnd>0, be aware that the most significant
'             dWord is expected at the array's highest position,
'             hence, the memory is physically rotated to the left!
'
Function lngROR( _
    sat As Long, _
    Optional cnt As Long = 1, _
    Optional bnd As Long = 0, _
    Optional cmd As Long = 0) As Long
    
    Static asm(35) As Long

    If asm(0) = 0 Then
        asm(0) = &H247C8B57:  asm(1) = &H244C8B08:  asm(2) = &H2464C010
        asm(3) = &H14740614:  asm(4) = &HC24548B:   asm(5) = &H107B0679
        asm(6) = &H1075D20B:  asm(7) = &H4A970CD3:  asm(8) = &H4EBFA79
        asm(9) = &HC8D3078B:  asm(10) = &H10C25F:   asm(11) = &H40C28B52
        asm(12) = &H5E8C191:  asm(13) = &HC1F1F799: asm(14) = &H317402E2
        asm(15) = &H8D535655: asm(16) = &H8D34&:    asm(17) = &HDF8B0000
        asm(18) = &HFC3E7C8D: asm(19) = &H8B57EF8B: asm(20) = &H2B078BFD
        asm(21) = &H73FB3BFA: asm(22) = &H87FE0302: asm(23) = &H9744907
        asm(24) = &HEF75FD3B: asm(25) = &HEB04ED83: asm(26) = &H5E5B5FE6
        asm(27) = &H1FB95A5D: asm(28) = &H23000000: asm(29) = &H7410244C
        asm(30) = &H8B37FFAF: asm(31) = &HAD0F0447: asm(32) = &H4C78307
        asm(33) = &H58F4754A: asm(34) = &HEB07AD0F: asm(35) = &H9B
    End If

    ' *******************************************************************

    lngROR = ASM_cdRF3(asm(0), sat, ByVal bnd, cnt, cmd)
End Function

' lngSWP    Swap longs
'           little endian to big endian (and vice versa)
'
' CALL:     lngSWP(src, [@tgt], [bnd])
'
' IN:       ptr:src Long v longarray to get values from
'           ptr:tgt Long v longarray to put results in
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'
' OUT:      lng     last processed value
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for src:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple swap command was lngSWP(V1)
'           - In order to put the converted value in the source
'             array call: lngSWP src(0), src(0), UBound(src)
'
Function lngSWP( _
    src As Long, _
    Optional tgt As Long, _
    Optional bnd As Long = 0) As Long
    
    Static asm(7) As Long

    If asm(0) = 0 Then
        asm(0) = &H748B5756:  asm(1) = &H7C8B0C24:  asm(2) = &H4C8B1024
        asm(3) = &H48B1424:   asm(4) = &H89C80F8E:  asm(5) = &HE9838F04
        asm(6) = &H5FF37301:  asm(7) = &H10C25E
    End If

    ' *******************************************************************

    lngSWP = ASM_cdRF3(asm(0), src, tgt, bnd, 0)
End Function

